#ifndef _ClassifBayes
#define _ClassifBayes

#include <cmath>
#include <string>
#include <vector>
#include <fstream>
#include "LoadData.h"

using namespace std;

// classifieur bayesien

class ClassifBayes {
	
public:
	
	ClassifBayes () {}
	
	ClassifBayes (string& typesAtt) {
		typesAttributs=typesAtt;
		nbAtt=typesAttributs.size();
	}
	
	~ClassifBayes () {}
	
	// trouve les parametres des gaussiennes
	void findParams();

	// classifie l'exemple de la ligne numLine
	string& classify(int numLine,bool testData);
	
	// affichage des parametres dans un fichier
	void printToFile();

	string typesAttributs;
	int nbAtt; // nombre d'attributs (pour alleger l'ecriture)
	// on memorise les probabilites de chaque classe,
	// ainsi que les parametres de chaque gaussienne representant une classe
	double* classesProba;
	
	// les probabilites de chaque symbole dans chaque classe:
	double*** distribSymb;
	
	// moyennes et matrices de covariances (stdDev[i][j+nbAttributs*k] ==> j-ieme colonne k-ieme ligne):
	double** means;
	double** stdDev;
};

#endif
