#ifndef _ClassifGaussMixt
#define _ClassifGaussMixt

#include <cmath>
#include <string>
#include <vector>
#include <list>
#include <fstream>
#include <algorithm>
#include "LoadData.h"
#include "MultiDimClassif.h"

using namespace std;

// classifieur base sur une mixture de gaussiennes + EM

class ClassifGaussMixt : MultiDimClassif {
	
public:
	
	ClassifGaussMixt () {}
	
	ClassifGaussMixt (string& typesAtt) {
		typesAttributs=typesAtt;
		nbAtt=typesAttributs.size();
	}
	
	~ClassifGaussMixt () {}

	// initialise le classifieur
	void initialize();

	// "adaptive k-means" en typesAttributs.size() dimensions (moins les identifiants)
	void ad_k_means();

	// l'algorithme EM:
	void exp_max();
	
	// classifie l'exemple de la ligne numLine, supposant initialize() appele
	string& classify(int numLine,bool testData);

	// affichage des parametres dans un fichier
	// remarque: les resultats de calculs avec valeurs inutiles (identifiants) sont simplement a zero
	void printToFile();
	
	// probabilites et classes des modes:
	ClassAndProba* probasClassModes;
	int nbModes; // nombre de modes

	static constexpr double EPSILON=0.001; // seuil de convergence pour l'algorithme k-means
	static constexpr double SIZE_FACTOR=0.2; // fraction de la taille moyenne d'un medoide
										// que celui-ci doit au moins avoir
	static constexpr double PLACE_CENTROID=1.5; // mi-distance en ecarts-types entre deux nouveaux centroides;
											// doit etre entre 1 et 2.
	static constexpr double CLUSTERING_THRESHOLD=0.7; // seuil de formation de clusters; entre 0 et 1
};

#endif
