#ifndef _ClassifTree
#define _ClassifTree

#include <string>
#include <vector>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include "LoadData.h"
#include "Functions.h"
#include "Noeud.h"
#include "Arbre.h"

using namespace std;

// types utiles pour reordonner les attributs entiers et flottants

struct FloatAndClass {
	FloatAndClass (double v,int clInd) {
		val=v;
		classIndex=clInd;
	}
	bool operator<(const FloatAndClass& fAndC) const {
		return val<fAndC.val;
	}
	double val;
	int classIndex;
};
struct IntAndClass {
	IntAndClass (int v,int clInd) {
		val=v;
		classIndex=clInd;
	}
	bool operator<(const IntAndClass& iAndC) const {
		return val<iAndC.val;
	}
	int val;
	int classIndex;
};

// type pour une chaine + vecteur booleen utile pour le split symbolique

struct StringAndClassesID {
	StringAndClassesID (const string& s,unsigned long long clID,bool* pb) {
		str=s;
		classesID=clID;
		pbool=pb;
	}
	string str;
	unsigned long long classesID;
	bool* pbool;
};

// la fonction de creation de l'arbre de decision
Arbre buildTree(char splitCriteria);

// fonction qui trouve les valeurs de split de part et d'autre d'un point de coupure
void computeSplit(vector<FloatAndClass>& valeursAtt,int& nbTotalExemples,int countMissingValues,double f,double& splitGauche,double& splitDroite,double& branchFact,char splitCriteria);

// des fonctions auxiliaires qui retournent la meilleure valeur de split
double findBestSplitSymbolic(Noeud* node,vector<vector<string> >& subsets,int& indexAtt,char splitCriteria);
double findBestSplitContinue(Noeud* node,double& cutFloat,int& indexAtt,char splitCriteria);
double findBestSplitDiscrete(Noeud* node,int& cutInt,int& indexAtt,char splitCriteria);
	
// fonctions pour determiner ou va aller une valeur manquante
int findIndexSymbolic(Noeud* node,const vector<vector<string> >& subsets,int indexAtt,const string& str);
int findIndexContinue(Noeud* node,double cutFloat,int indexAtt,const string& str);
int findIndexDiscrete(Noeud* node,int cutInt,int indexAtt,const string& str);

#endif
