#ifndef _Functions
#define _Functions

#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>

using namespace std;

class Functions {
	
public:
	
	Functions () {}

	~Functions () {}

	// une petite fonction auxiliaire: elevation au carre
	static double square(double f) {
		return f*f;
	}
	
	// fonctions max auxiliaires
	static char maxm(double valSplitSymb,double valSplitCont,double valSplitDisc) {
		char maximum;
		if (valSplitSymb>valSplitCont) {
			if (valSplitSymb>valSplitDisc) maximum='s';
			else maximum='d';
		}
		else {
			if (valSplitCont>valSplitDisc) maximum='c';
			else maximum='d';
		}
		return maximum;
	}
		
	static double maxm(double a,double b) {
		if (a>b) return a;
		return b;
	}
	
	static int maxi(int a,int b) {
		if (a>b) return a;
		return b;
	}
	
	// puis min:
	static double minm(double a,double b) {
		if (a<b) return a;
		return b;
	}
	
	// une fonction auxiliaire qui trouve l'index d'une chaine dans un vecteur
	static int getIndexIn(const vector<vector<string> >& subsets,const string& str) {
		for (int i=subsets.size()-1; i>=0; i--) {
			for (int j=subsets[i].size()-1; j>=0; j--)
				if (subsets[i][j]==str) return i;
		}
		return -1; // n'arrive jamais si pas de bugs
	}
	
	// une autre fonction qui indique si une chaine est dans un ensemble de chaines
	static bool isIn(const string& str,const vector<string>& vs) {
		for (int i=vs.size()-1; i>=0; i--)
			if (vs[i]==str) return true;
		return false;
	}
	
	// fonctions qui convertissent des strings en entiers/flottants via atoi/atof
	static double toFloat(const string& str) {
		char* ch=(char*)calloc(str.size()+1,sizeof(char));
		for (int i=str.size()-1; i>=0; i--) ch[i]=str[i];
		double res=atof(ch);
		free(ch);
		return res;
	}
	static int toInt(const string& str) {
		char* ch=(char*)calloc(str.size()+1,sizeof(char));
		for (int i=str.size()-1; i>=0; i--) ch[i]=str[i];
		int res=atoi(ch);
		free(ch);
		return res;
	}
};

#define square Functions::square
#define maxm Functions::maxm
#define maxi Functions::maxi
#define minm Functions::minm
#define getIndexIn Functions::getIndexIn
#define isIn Functions::isIn
#define toFloat Functions::toFloat
#define toInt Functions::toInt

#endif
