#include "Knn.h"

// fonction distance auxiliaire
double distance_TA(int i,int j) {
	int count=0,numMatch=0,numTot=0;
	double dist=0.0;

	for (int l=attSymbolic_A.size()-1; l>=0; l--) {
		if (!attSymbolic_T[l][i].miss && !attSymbolic_A[l][j].miss) {
			if (attSymbolic_T[l][i].str==attSymbolic_A[l][j].str) numMatch++;
			numTot++;
			count++;
		}
	}
	dist+=(1.0-(double)numMatch/(numTot+1));

	for (int l=attContinue_A.size()-1; l>=0; l--) {
		if (!attContinue_T[l][i].miss && !attContinue_A[l][j].miss) {
			dist+=fabs(new_attContinue_T[l][i]-new_attContinue_A[l][j]);
			count++;
		}
	}
	
	for (int l=attDiscrete_A.size()-1; l>=0; l--) {
		if (!attDiscrete_T[l][i].miss && !attDiscrete_A[l][j].miss) {
			dist+=fabs(new_attDiscrete_T[l][i]-new_attDiscrete_A[l][j]);
			count++;
		}
	}
	
	if (count==0) return MAX_DOUBLE;
	return dist/count;
}

string& classify_knn(int numLine,int k) {
	// on cherche les k plus proches voisins de la ligne numLine
	double d,*dist=(double*)malloc(k*sizeof(double));
	int* lineNum=(int*)malloc(k*sizeof(int));
	for (int j=k-1; j>=0; j--) dist[j]=MAX_DOUBLE;
	for (int j=nbLines_A-1; j>=0; j--) {
		d=distance_TA(numLine,j);
		for (int l=0; l<k; l++) {
			if (d<dist[l]) {
				// decalage des plus proches voisins:
				for (int m=k-1; m>l; m--) {
					dist[m]=dist[m-1];
					lineNum[m]=lineNum[m-1];
				}
				dist[l]=d;
				lineNum[l]=j;
				break;
			}
		}
	}

	// puis la classe dominante parmi ces voisins;
	// si le choix est impossible, on met le label "unknown_class"
	int maxRep=0,bestIndex=-1;
	int* repartitions=(int*)calloc(initData.size(),sizeof(int));
	for (int j=k-1; j>=0; j--) repartitions[classIndex_A[lineNum[j]]]++;
	for (int j=nbClasses-1; j>=0; j--) {
		if (repartitions[j]>maxRep) {
			maxRep=repartitions[j];
			bestIndex=j;
		}
		else if (repartitions[j]==maxRep) maxRep=0;
	}

	// liberations memoire
	free(lineNum);
	free(repartitions);

	if (maxRep==0) return UNKNOWN_CLASS;
	return initData[bestIndex].str;
}
