#include "LoadData.h"

vector<StringOuMiss*> LoadData::attSymbolic_A,LoadData::attSymbolic_T;
vector<FloatOuMiss*> LoadData::attContinue_A,LoadData::attContinue_T;
vector<IntOuMiss*> LoadData::attDiscrete_A,LoadData::attDiscrete_T;
int LoadData::nbClasses;
string* LoadData::classes_A;
string* LoadData::classes_T;
int LoadData::nbLines_A,LoadData::nbLines_T;
int* LoadData::tabIndex;
int* LoadData::classIndex_A;
int* LoadData::classIndex_T;
vector<StringIndexCounter> LoadData::initData;
vector<string> LoadData::symbols;
int** LoadData::indexOfSymbol_A;
int** LoadData::indexOfSymbol_T;
int LoadData::nbSymbols;
double** LoadData::new_attContinue_A;
double** LoadData::new_attContinue_T;
double** LoadData::new_attDiscrete_A;
double** LoadData::new_attDiscrete_T;
int LoadData::nbRealAtt;
string LoadData::UNKNOWN_CLASS="unknown_class";

// chargement des donnees (entrainement ou test)
void LoadData::loadFromFile(char* name,const string& typesAttributs,string dataType) {
	ifstream countLinesFile(name);
	if (!countLinesFile.is_open()) {
		cout << "erreur, le fichier " << name << " n'existe pas" << endl;
		exit(EXIT_FAILURE);
	}
	// on cherche d'abord le nombre de lignes de la BDD
	int nbLines=0; 
	while (countLinesFile.ignore(numeric_limits<int>::max(),'\n')) {
		nbLines++;
	}
	countLinesFile.close();

	// initialisation des structures de donnees (une colonne~=un pointeur)
	vector<StringOuMiss*> attSymbolic;
	vector<FloatOuMiss*> attContinue;
	vector<IntOuMiss*> attDiscrete;
	if (dataType=="train") {
		tabIndex=(int*)malloc(typesAttributs.size()*sizeof(int));
		int nbSymb=0,nbCont=0,nbDisc=0; // pour le remplissage du tableau d'index
		for (int i=0; i<(int)typesAttributs.size(); i++) {
			if (typesAttributs[i]=='s') {
				attSymbolic.push_back(new StringOuMiss[nbLines]);
				tabIndex[i]=nbSymb;
				nbSymb++;
			}
			else if (typesAttributs[i]=='c') {
				attContinue.push_back(new FloatOuMiss[nbLines]);
				tabIndex[i]=nbCont;
				nbCont++;
			}
			else if (typesAttributs[i]=='d') {
				attDiscrete.push_back(new IntOuMiss[nbLines]);
				tabIndex[i]=nbDisc;
				nbDisc++;
			}
		}
	}
	else {
		for (int i=0; i<(int)typesAttributs.size(); i++) {
			if (typesAttributs[i]=='s') attSymbolic.push_back(new StringOuMiss[nbLines]);
			else if (typesAttributs[i]=='c') attContinue.push_back(new FloatOuMiss[nbLines]);
			else if (typesAttributs[i]=='d') attDiscrete.push_back(new IntOuMiss[nbLines]);
		}
	}

	// on recopie ensuite la base de donnees dans une structure plus adequate
	ifstream dataFile(name);
	string line,nomClasse,strTmp;
	string* classes=new string[nbLines];
	int* classIndex=(int*)malloc(nbLines*sizeof(int));
	int countLines=0,countAtt,i;
	string::iterator curChar,startPoint,memCurChar;
	bool newSubstring; // indique si on est en train de lire une nouvelle valeur
	if (dataType=="train") nbClasses=0;
	while (getline(dataFile,line,'\n')) {
		if (line.empty()) break; // escaper si \n en fin de fichier
		countAtt=0; // compte le nombre d'attributs lus
		newSubstring=true;
		for (curChar=line.begin(); curChar!=line.end(); curChar++) {
			if (newSubstring && *curChar!=',') {
				startPoint=curChar;
				newSubstring=false;
			}
			else if (*curChar==',') { // on ignore les espaces au debut et a la fin des chaines
				while (*startPoint==' ') startPoint++;
				memCurChar=curChar;
				while (*(curChar-1)==' ') curChar--;
				strTmp=string(startPoint,curChar);
				curChar=memCurChar;
				if (strTmp=="?") {
					if (typesAttributs[countAtt]=='s')
						attSymbolic[tabIndex[countAtt]][countLines].miss=true;
					else if (typesAttributs[countAtt]=='c') {
						attContinue[tabIndex[countAtt]][countLines].miss=true;
						attContinue[tabIndex[countAtt]][countLines].isInit=true;
					}
					else if (typesAttributs[countAtt]=='d') {
						attDiscrete[tabIndex[countAtt]][countLines].miss=true;
						attDiscrete[tabIndex[countAtt]][countLines].isInit=true;
					}
				}
				else {
					if (typesAttributs[countAtt]=='s')
						attSymbolic[tabIndex[countAtt]][countLines].str=strTmp;
					else if (typesAttributs[countAtt]=='c') {
						attContinue[tabIndex[countAtt]][countLines].val=toFloat(strTmp);
						attContinue[tabIndex[countAtt]][countLines].isInit=true;
					}
					else if (typesAttributs[countAtt]=='d') {
						attDiscrete[tabIndex[countAtt]][countLines].val=toInt(strTmp);
						attDiscrete[tabIndex[countAtt]][countLines].isInit=true;
					}
				}
				newSubstring=true;
				countAtt++;
			}
			if (countAtt==(int)typesAttributs.size()) break;
		}
		startPoint=++curChar;
		while (curChar!=line.end()) curChar++;
		while (*startPoint==' ') startPoint++;
		while (*(curChar-1)==' ') curChar--;
		nomClasse=string(startPoint,curChar);
		classes[countLines]=nomClasse;
		if (dataType=="train") {
			for (i=initData.size()-1; i>=0; i--) {
				if (nomClasse==initData[i].str) {
					initData[i].counter++;
					initData[i].occurrences.push_back(countLines);
					classIndex[countLines]=i;
					break;
				}
			}
			if (i<0) {
				initData.push_back(StringIndexCounter(nomClasse,nbClasses,1));
				initData.back().occurrences.push_back(countLines);
				classIndex[countLines]=initData.size()-1;
				nbClasses++;
			}
		}
		else {
			for (i=initData.size()-1; i>=0; i--) {
				if (nomClasse==initData[i].str) {
					classIndex[countLines]=i;
					break;
				}
			}
		}
		countLines++;
	}
	dataFile.close();

	// test pour savoir si nbLines ou nbLines-1 ..etc (si plusieurs sauts de ligne en fin de fichier)
	// on tire parti du fait que les chaines sont initialisees a "" (similaires aux vecteurs)
	i=nbLines-1;
	if (!attSymbolic.empty())
		while (attSymbolic[0][i].str.empty()) i--;
	else if (!attContinue.empty())
		while (!attContinue[0][i].isInit) i--;
	else
		while (!attDiscrete[0][i].isInit) i--;
	nbLines=i+1; // important pour les stats finales

	if (dataType=="train") {
		nbRealAtt=attSymbolic.size()+attContinue.size()+attDiscrete.size();
		attSymbolic_A=attSymbolic;
		attContinue_A=attContinue;
		attDiscrete_A=attDiscrete;
		classes_A=classes;
		nbLines_A=nbLines;
		classIndex_A=classIndex;
	}
	else {
		attSymbolic_T=attSymbolic;
		attContinue_T=attContinue;
		attDiscrete_T=attDiscrete;
		classes_T=classes;
		nbLines_T=nbLines;
		classIndex_T=classIndex;
	}	
}

// recuperation des distributions de probabilite des donnees symboliques
void LoadData::getDistribSymbolic() {
	// recherche des symboles presents en leur assignant un index representant leur valeur
	int k,countIndex=0;
	indexOfSymbol_A=(int**)malloc(attSymbolic_A.size()*sizeof(int*));
	indexOfSymbol_T=(int**)malloc(attSymbolic_A.size()*sizeof(int*));
	for (int i=attSymbolic_A.size()-1; i>=0; i--) {
		indexOfSymbol_A[i]=(int*)malloc(nbLines_A*sizeof(int));
		for (int j=nbLines_A-1; j>=0; j--) {
			if (attSymbolic_A[i][j].miss) continue;
			for (k=symbols.size()-1; k>=0; k--)
				if (attSymbolic_A[i][j].str==symbols[k]) break;
			if (k<0) {
				indexOfSymbol_A[i][j]=countIndex;
				symbols.push_back(attSymbolic_A[i][j].str);
				countIndex++;
			}
			else indexOfSymbol_A[i][j]=k;
		}
	}
	for (int i=attSymbolic_A.size()-1; i>=0; i--) {
		indexOfSymbol_T[i]=(int*)malloc(nbLines_T*sizeof(int));
		for (int j=nbLines_T-1; j>=0; j--) {
			if (attSymbolic_T[i][j].miss) continue;
			for (k=symbols.size()-1; k>=0; k--)
				if (attSymbolic_T[i][j].str==symbols[k]) break;
			indexOfSymbol_T[i][j]=k;
		}
	}
	nbSymbols=symbols.size();
}

// normalisation des donnees continues/discretes (utiles pour calculer des distances)
void LoadData::normalizeData() {
	if (attSymbolic_A.empty()) {
		// allocations memoire
		double* moyennesC=(double*)calloc(attContinue_A.size(),sizeof(double));
		double* moyennesD=(double*)calloc(attDiscrete_A.size(),sizeof(double));
		double* ecartsTypesC=(double*)calloc(attContinue_A.size(),sizeof(double));
		double* ecartsTypesD=(double*)calloc(attDiscrete_A.size(),sizeof(double));
		int* countC=(int*)calloc(attContinue_A.size(),sizeof(int));
		int* countD=(int*)calloc(attDiscrete_A.size(),sizeof(int));
	
		// calcul des sommes des valeurs et de leurs carres
		for (int i=nbLines_A-1; i>=0; i--) {
			for (int j=attContinue_A.size()-1; j>=0; j--) {
				if (!attContinue_A[j][i].miss) {
					moyennesC[j]+=attContinue_A[j][i].val;
					ecartsTypesC[j]+=attContinue_A[j][i].val*attContinue_A[j][i].val;
					countC[j]++;
				}
			}
			for (int j=attDiscrete_A.size()-1; j>=0; j--) {
				if (!attDiscrete_A[j][i].miss) {
					moyennesD[j]+=attDiscrete_A[j][i].val;
					ecartsTypesD[j]+=attDiscrete_A[j][i].val*attDiscrete_A[j][i].val;
					countD[j]++;
				}
			}
		}
	
		// normalisation pour obtenir les moyennes, puis les ecarts-types
		for (int i=attContinue_A.size()-1; i>=0; i--) {
			if (countC[i]>0) {
				moyennesC[i]/=countC[i];
				ecartsTypesC[i]=sqrt(ecartsTypesC[i]/countC[i]-moyennesC[i]*moyennesC[i]);
			}
		}
		for (int i=attDiscrete_A.size()-1; i>=0; i--) {
			if (countD[i]>0) {
				moyennesD[i]/=countD[i];
				ecartsTypesD[i]=sqrt(ecartsTypesD[i]/countD[i]-moyennesD[i]*moyennesD[i]);
			}
		}
		
		// liberations memoire
		free(moyennesC);
		free(moyennesD);
		free(countC);
		free(countD);
	
		// copie puis modification des donnees initiales:
		/* NOTE: les exemples tests sont connus donc on les normalise ici,
		 * mais dans le cas ou on ne dispose que de l'ensemble d'entrainement
		 * il suffit de normaliser les exemples tests au fur et a mesure de leur arrivee,
		 * en changeant legerement les structures utilisees pour tester les donnees */
		new_attContinue_A=(double**)malloc(attContinue_A.size()*sizeof(double*));
		new_attContinue_T=(double**)malloc(attContinue_A.size()*sizeof(double*));
		for (int i=attContinue_A.size()-1; i>=0; i--) {
			new_attContinue_A[i]=((double*)malloc(nbLines_A*sizeof(double)));
			for (int j=nbLines_A-1; j>=0; j--) {
				if (!attContinue_A[i][j].miss) {
					new_attContinue_A[i][j]=attContinue_A[i][j].val;
					if (ecartsTypesC[i]>0.0) new_attContinue_A[i][j]/=ecartsTypesC[i];
				}
			}
			new_attContinue_T[i]=((double*)malloc(nbLines_T*sizeof(double)));
			for (int j=nbLines_T-1; j>=0; j--) {
				if (!attContinue_A[i][j].miss) {
					new_attContinue_T[i][j]=attContinue_T[i][j].val;
					if (ecartsTypesC[i]>0.0) new_attContinue_T[i][j]/=ecartsTypesC[i];
				}
			}
		}
	
		new_attDiscrete_A=(double**)malloc(attDiscrete_A.size()*sizeof(double*));
		new_attDiscrete_T=(double**)malloc(attDiscrete_A.size()*sizeof(double*));
		for (int i=attDiscrete_A.size()-1; i>=0; i--) {
			new_attDiscrete_A[i]=((double*)malloc(nbLines_A*sizeof(double)));
			for (int j=nbLines_A-1; j>=0; j--) {
				if (!attDiscrete_A[i][j].miss) {
					new_attDiscrete_A[i][j]=attDiscrete_A[i][j].val;
					if (ecartsTypesD[i]>0.0) new_attDiscrete_A[i][j]/=ecartsTypesD[i];
				}
			}
			new_attDiscrete_T[i]=((double*)malloc(nbLines_T*sizeof(double)));
			for (int j=nbLines_T-1; j>=0; j--) {
				if (!attDiscrete_A[i][j].miss) {
					new_attDiscrete_T[i][j]=attDiscrete_T[i][j].val;
					if (ecartsTypesD[i]>0.0) new_attDiscrete_T[i][j]/=ecartsTypesD[i];
				}
			}
		}
		
		// liberations memoire
		free(ecartsTypesC);
		free(ecartsTypesD);
	}
	else {
		// s'il y a des attributs symboliques, on recherche les plus grandes et plus petites valeurs
		// des attributs numeriques pour les normaliser "environ" entre 0 et 1;
		// ainsi ils seront du meme ordre de grandeur ques les probabilites des attributs symboliques
		// utilisees pour les calculs de distance.
		
		// d'abord on determine la marge du nombre d'extremums (pour ne pas tenir compte des outliers)
		int nbExt=maxi((int)floor(0.01*nbLines_A),1); // possibilite de changer ce 0.01
		double** tabMinC=(double**)malloc(attContinue_A.size()*sizeof(double*));
		double** tabMaxC=(double**)malloc(attContinue_A.size()*sizeof(double*));
		for (int i=attContinue_A.size()-1; i>=0; i--) {
			tabMinC[i]=(double*)malloc(nbExt*sizeof(double));
			tabMaxC[i]=(double*)malloc(nbExt*sizeof(double));
			for (int j=nbExt-1; j>=0; j--) {
				tabMinC[i][j]=MAX_DOUBLE;
				tabMaxC[i][j]=-MAX_DOUBLE;
			}
		}
		for (int i=attContinue_A.size()-1; i>=0; i--) {
			for (int j=nbLines_A-1; j>=0; j--) {
				if (attContinue_A[i][j].miss) continue;
				for (int k=0; k<nbExt; k++) {
					if (attContinue_A[i][j].val<tabMinC[i][k]) {
						// decalage des elements du tableau:
						for (int l=nbExt-1; l>=k+1; l--) tabMinC[i][l]=tabMinC[i][l-1];
						// insertion de la nouvelle valeur:
						tabMinC[i][k]=attContinue_A[i][j].val;
						break;
					}
					if (attContinue_A[i][j].val>tabMaxC[i][k]) {
						// decalage des elements du tableau:
						for (int l=nbExt-1; l>=k+1; l--) tabMaxC[i][l]=tabMaxC[i][l-1];
						// insertion de la nouvelle valeur:
						tabMaxC[i][k]=attContinue_A[i][j].val;
						break;
					}
				}
			}
		}
		double** tabMinD=(double**)malloc(attDiscrete_A.size()*sizeof(double*));
		double** tabMaxD=(double**)malloc(attDiscrete_A.size()*sizeof(double*));
		for (int i=attDiscrete_A.size()-1; i>=0; i--) {
			tabMinD[i]=(double*)malloc(nbExt*sizeof(double));
			tabMaxD[i]=(double*)malloc(nbExt*sizeof(double));
			for (int j=nbExt-1; j>=0; j--) {
				tabMinD[i][j]=MAX_DOUBLE;
				tabMaxD[i][j]=-MAX_DOUBLE;
			}
		}
		for (int i=attDiscrete_A.size()-1; i>=0; i--) {
			for (int j=nbLines_A-1; j>=0; j--) {
				if (attDiscrete_A[i][j].miss) continue;
				for (int k=0; k<nbExt; k++) {
					if (attDiscrete_A[i][j].val<tabMinD[i][k]) {
						// decalage des elements du tableau:
						for (int l=nbExt-1; l>=k+1; l--) tabMinD[i][l]=tabMinD[i][l-1];
						// insertion de la nouvelle valeur:
						tabMinD[i][k]=attDiscrete_A[i][j].val;
						break;
					}
					if (attDiscrete_A[i][j].val>tabMaxD[i][k]) {
						// decalage des elements du tableau:
						for (int l=nbExt-1; l>=k+1; l--) tabMaxD[i][l]=tabMaxD[i][l-1];
						// insertion de la nouvelle valeur:
						tabMaxD[i][k]=attDiscrete_A[i][j].val;
						break;
					}
				}
			}
		}

		// et on initialise les donnees:
		new_attContinue_A=(double**)malloc(attContinue_A.size()*sizeof(double*));
		new_attContinue_T=(double**)malloc(attContinue_A.size()*sizeof(double*));
		for (int i=attContinue_A.size()-1; i>=0; i--) {
			new_attContinue_A[i]=((double*)malloc(nbLines_A*sizeof(double)));
			for (int j=nbLines_A-1; j>=0; j--) {
				if (!attContinue_A[i][j].miss) {
					new_attContinue_A[i][j]=attContinue_A[i][j].val;
					if (tabMaxC[i][nbExt-1]!=tabMinC[i][nbExt-1])
						new_attContinue_A[i][j]=(new_attContinue_A[i][j]-tabMinC[i][nbExt-1])/(tabMaxC[i][nbExt-1]-tabMinC[i][nbExt-1]);
				}
			}
			new_attContinue_T[i]=((double*)malloc(nbLines_T*sizeof(double)));
			for (int j=nbLines_T-1; j>=0; j--) {
				if (!attContinue_A[i][j].miss) {
					new_attContinue_T[i][j]=attContinue_T[i][j].val;
					if (tabMaxC[i][nbExt-1]!=tabMinC[i][nbExt-1])
						new_attContinue_T[i][j]=(new_attContinue_T[i][j]-tabMinC[i][nbExt-1])/(tabMaxC[i][nbExt-1]-tabMinC[i][nbExt-1]);
				}
			}
		}
	
		new_attDiscrete_A=(double**)malloc(attDiscrete_A.size()*sizeof(double*));
		new_attDiscrete_T=(double**)malloc(attDiscrete_A.size()*sizeof(double*));
		for (int i=attDiscrete_A.size()-1; i>=0; i--) {
			new_attDiscrete_A[i]=((double*)malloc(nbLines_A*sizeof(double)));
			for (int j=nbLines_A-1; j>=0; j--) {
				if (!attDiscrete_A[i][j].miss) {
					new_attDiscrete_A[i][j]=attDiscrete_A[i][j].val;
					if (tabMaxD[i][nbExt-1]!=tabMinD[i][nbExt-1])
						new_attDiscrete_A[i][j]=(new_attDiscrete_A[i][j]-tabMinD[i][nbExt-1])/(tabMaxD[i][nbExt-1]-tabMinD[i][nbExt-1]);
				}
			}
			new_attDiscrete_T[i]=((double*)malloc(nbLines_T*sizeof(double)));
			for (int j=nbLines_T-1; j>=0; j--) {
				if (!attDiscrete_A[i][j].miss) {
					new_attDiscrete_T[i][j]=attDiscrete_T[i][j].val;
					if (tabMaxD[i][nbExt-1]!=tabMinD[i][nbExt-1])
						new_attDiscrete_T[i][j]=(new_attDiscrete_T[i][j]-tabMinD[i][nbExt-1])/(tabMaxD[i][nbExt-1]-tabMinD[i][nbExt-1]);
				}
			}
		}
		
		// liberations memoire
		for (int i=attContinue_A.size()-1; i>=0; i--) {
			free(tabMinC[i]);
			free(tabMaxC[i]);
		}
		free(tabMinC);
		free(tabMaxC);
		for (int i=attDiscrete_A.size()-1; i>=0; i--) {
			free(tabMinD[i]);
			free(tabMaxD[i]);
		}
		free(tabMinD);
		free(tabMaxD);
	}
}
