#ifndef _MultiDimClassif
#define _MultiDimClassif

#include <cmath>
#include <string>
#include <vector>
#include <list>
#include <fstream>
#include "LoadData.h"

// classe de base pour les classifieurs multidimensionnels comme Gauss et GaussMixt

class MultiDimClassif {
	
public:
	
	MultiDimClassif () {}
	
	~MultiDimClassif () {}

	// effectue l'initialisation
	void initialize();
	
	// fonctions auxiliaires pour realiser la classification:
	double* pivotGauss(double* matrice);
	double determinant(double* matrice);
	double* multMatrix(double* m1,double* m2);
	double normeCarree(int numLine,int indexClass,bool testData);

	// initialise les matrices inverses et determinants (de taille size)
	void initClassify(int size);
	
	// classifie l'exemple de la ligne numLine, supposant initialize() appele
	string& classify(int numLine,bool testData);

	// affichage des parametres dans un fichier
	// remarque: les resultats de calculs avec valeurs inutiles (identifiants) sont simplement a zero
	void printToFile();
	
	string typesAttributs;
	int nbAtt; // nombre d'attributs (pour alleger l'ecriture)
	
	// moyennes et matrices de covariances (cov[i][j+nbAttributs*k] ==> j-ieme colonne k-ieme ligne):
	double** means;
	double** cov;
	
	// les probabilites de chaque symbole dans chaque classe ou mode:
	vector<double**> distribSymb;

	// pour la classification: valeurs absolues des determinants et matrices de covariances inversees
	double* determinants;
	double** inv_cov;
};

#endif
